---
openapi: 3.0.1
info:
  title: WelcomeHome API V1
  version: v1
  description: |+
    ## Authorization Request Header

    When making requests, include your API Token in an Authorization request header
    like so:

    ```
    Authorization: Token token={your_token_here}
    ```

    You can test your API token using the "/api/ping" endpoint. For example:

    ```
    curl https://crm.welcomehomesoftware.com/api/ping -H "Authorization: Token token={token_here}"
    ```

    A successful authentication returns with response code 200 and a JSON body
    describing the account the token provides access to. E.g.,

    ```
    {"account_id":2,"lead_source_id":null}
    ```

    A failed authentication returns with response code 401 and the message:

    ```
    {"error":"Bad credentials"}
    ```

    A failed authorization returns with response code 403 and the message:

    ```
    {"error":"Not authorized to perform this action"}
    ```

paths:
  "/activities":
    get:
      summary: List Activities
      tags:
      - Activities
      parameters:
      - name: limit
        in: query
        required: false
        description: |
          Numbers of records to return per page.
          See response details below to learn about pagination.
          Default: `10`.
          Maximum: `100`.
        schema:
          type: integer
      - name: filters[activity_type_id]
        in: query
        required: false
        description: 'Activity Type ID to search on.

          '
        schema:
          type: integer
      - name: filters[created_at_after]
        in: query
        required: false
        example: '2000-01-01T00:00:00Z'
        schema:
          type: string
      - name: filters[created_at_before]
        in: query
        required: false
        example: '2000-01-01T00:00:00Z'
        schema:
          type: string
      - name: filters[updated_at_after]
        in: query
        required: false
        example: '2000-01-01T00:00:00Z'
        schema:
          type: string
      - name: filters[updated_at_before]
        in: query
        required: false
        example: '2000-01-01T00:00:00Z'
        schema:
          type: string
      responses:
        '200':
          description: list activities (expand to read about pagination)
          headers:
            Link:
              type: string
              description: |
                If the response has been paginated and there are more records to
                retrieve, the "Link" header will be present with a URL that can be used to
                fetch the next page.

                E.g., `Link: <https://crm.welcomehomesoftware.com/api/path/to/endpoint?cursor=6eb0d8c2e74cedf3>; rel="next"`

                Note: a given cursor can only be used 3 times within a single minute, a
                limit imposed to mitigate infinitely pulling the same page.
          content:
            application/json:
              schema:
                type: array
                items:
                  type: object
                  properties:
                    id:
                      type: integer
                    completed_at:
                      type: string
                      format: date-time
                    direction:
                      type: string
                    notes:
                      type: string
                    sales_counselor_id:
                      type: integer
                    scheduled_at:
                      type: string
                      format: date-time
                    created_at:
                      type: string
                      format: date-time
                    updated_at:
                      type: string
                      format: date-time
                    record_type:
                      type: string
                    record_id:
                      type: integer
                    stage_id:
                      type: integer
                    activity_type_id:
                      type: integer
                    discarded_at:
                      type: string
                      format: date-time
                    activity_result_id:
                      type: integer
                    pinned:
                      type: boolean
                    community_id:
                      type: integer
                    created_by_id:
                      type: integer
                    completed_successfully:
                      type: boolean
                    add_to_calendar:
                      type: boolean
                    time_zone:
                      type: string
                      nullable: false
                      example: Eastern Time (US & Canada)
                    calendar_event_start_time:
                      type: string
                      example: '14:00'
                    calendar_event_end_time:
                      type: string
                      example: '15:00'
                    person_ids:
                      type: array
                      items:
                        type: integer
  "/prospects/{prospect_id}/activities":
    get:
      summary: List Prospect Activities
      tags:
      - Activities
      responses:
        '200':
          description: list activities
          content:
            application/json:
              schema:
                type: array
                items:
                  type: object
                  properties:
                    id:
                      type: integer
                    completed_at:
                      type: string
                      format: date-time
                    direction:
                      type: string
                    notes:
                      type: string
                    sales_counselor_id:
                      type: integer
                    scheduled_at:
                      type: string
                      format: date-time
                    created_at:
                      type: string
                      format: date-time
                    updated_at:
                      type: string
                      format: date-time
                    record_type:
                      type: string
                    record_id:
                      type: integer
                    stage_id:
                      type: integer
                    activity_type_id:
                      type: integer
                    discarded_at:
                      type: string
                      format: date-time
                    activity_result_id:
                      type: integer
                    pinned:
                      type: boolean
                    community_id:
                      type: integer
                    created_by_id:
                      type: integer
                    completed_successfully:
                      type: boolean
                    add_to_calendar:
                      type: boolean
                    time_zone:
                      type: string
                      nullable: false
                      example: Eastern Time (US & Canada)
                    calendar_event_start_time:
                      type: string
                      example: '14:00'
                    calendar_event_end_time:
                      type: string
                      example: '15:00'
                    person_ids:
                      type: array
                      items:
                        type: integer
    post:
      summary: Create Activity
      tags:
      - Activities
      description: |+
        To add a start and end time, `"add_to_calendar": true` must be passed
        along with time_zone, calendar_event_start_time, and
        calendar_event_end_time. calendar_event_start_time and
        calendar_event_end_time also support Meridian indicators like "3:00 PM".
        The standard North American time zones are:
        ["Eastern Time (US & Canada)", "Central Time (US & Canada)", "Mountain Time (US & Canada)", "Pacific Time (US & Canada)", "Alaska", "Arizona", "Hawaii"]

      parameters: []
      responses:
        '200':
          description: Create an activity
          content:
            application/json:
              schema:
                type: object
                properties:
                  id:
                    type: integer
                  completed_at:
                    type: string
                    format: date-time
                  direction:
                    type: string
                  notes:
                    type: string
                  sales_counselor_id:
                    type: integer
                  scheduled_at:
                    type: string
                    format: date-time
                  created_at:
                    type: string
                    format: date-time
                  updated_at:
                    type: string
                    format: date-time
                  record_type:
                    type: string
                  record_id:
                    type: integer
                  stage_id:
                    type: integer
                  activity_type_id:
                    type: integer
                  discarded_at:
                    type: string
                    format: date-time
                  activity_result_id:
                    type: integer
                  pinned:
                    type: boolean
                  community_id:
                    type: integer
                  created_by_id:
                    type: integer
                  completed_successfully:
                    type: boolean
                  time_zone:
                    type: string
                    nullable: false
                    example: Eastern Time (US & Canada)
                  calendar_event_start_time:
                    type: string
                    example: '14:00'
                  calendar_event_end_time:
                    type: string
                    example: '15:00'
                  person_ids:
                    type: array
                    items:
                      type: integer
      requestBody:
        content:
          application/json:
            schema:
              type: object
              properties:
                activity:
                  type: object
                  properties:
                    activity_result_id:
                      type: integer
                    activity_type_id:
                      type: integer
                    completed_at:
                      type: string
                      format: date-time
                      description: If null, activity is scheduled to be performed
                    direction:
                      type: string
                      description: One of 'inbound' or 'outbound'
                    notes:
                      type: string
                      description: |
                        Can include basic HTML. Allowed elements:
                        <code>
                        a abbr acronym address b big blockquote br cite code dd del dfn div dl dt em h1 h2 h3 h4 h5 h6 hr i img ins kbd li mark ol p pre samp small span strong sub sup time tt ul var
                        </code>
                    pinned:
                      type: boolean
                      description: |
                        Pinned activities are pinned to the top of the completed
                        activities list that users see. They are also displayed
                        along with the life story.
                    sales_counselor_id:
                      type: integer
                    scheduled_at:
                      type: string
                      format: date-time
                      description: 'Note: users only see the scheduled date, not the
                        time.

                        '
                    add_to_calendar:
                      type: boolean
                      description: |
                        If true, time_zone, calendar_event_start_time, and
                        calendar_event_end_time will be required
                    time_zone:
                      type: string
                      nullable: false
                      example: Eastern Time (US & Canada)
                      description: |
                        The standard North American time zones are:
                        ["Eastern Time (US & Canada)", "Central Time (US & Canada)", "Mountain Time (US & Canada)", "Pacific Time (US & Canada)", "Alaska", "Arizona", "Hawaii"]
                    calendar_event_start_time:
                      type: string
                      example: '14:00'
                      description: |
                        Supports both military time and 12-hour time with Meridian indicators
                        like "2:00 PM"
                    calendar_event_end_time:
                      type: string
                      example: '15:00'
                      description: |
                        Supports both military time and 12-hour time with Meridian indicators
                        like "3:00 PM"
                    person_ids:
                      type: array
                      items:
                        type: integer
                      description: 'A list of person IDs of any people included in
                        the activity

                        '
                  required:
                  - activity_type_id
  "/prospects/{prospect_id}/activities/{activity_id}":
    put:
      summary: Update Prospect Activity
      tags:
      - Activities
      description: |+
        To add a start and end time, `"add_to_calendar": true` must be passed
        along with time_zone, calendar_event_start_time, and
        calendar_event_end_time. calendar_event_start_time and
        calendar_event_end_time also support Meridian indicators like "3:00 PM".
        The standard North American time zones are:
        ["Eastern Time (US & Canada)", "Central Time (US & Canada)", "Mountain Time (US & Canada)", "Pacific Time (US & Canada)", "Alaska", "Arizona", "Hawaii"]

      parameters: []
      responses:
        '200':
          description: success
          content:
            application/json:
              schema:
                type: object
                properties:
                  id:
                    type: integer
                  completed_at:
                    type: string
                    format: date-time
                  direction:
                    type: string
                  notes:
                    type: string
                  sales_counselor_id:
                    type: integer
                  scheduled_at:
                    type: string
                    format: date-time
                  created_at:
                    type: string
                    format: date-time
                  updated_at:
                    type: string
                    format: date-time
                  record_type:
                    type: string
                  record_id:
                    type: integer
                  stage_id:
                    type: integer
                  activity_type_id:
                    type: integer
                  discarded_at:
                    type: string
                    format: date-time
                  activity_result_id:
                    type: integer
                  pinned:
                    type: boolean
                  community_id:
                    type: integer
                  created_by_id:
                    type: integer
                  completed_successfully:
                    type: boolean
                  add_to_calendar:
                    type: boolean
                  time_zone:
                    type: string
                    nullable: false
                    example: Eastern Time (US & Canada)
                  calendar_event_start_time:
                    type: string
                    example: '14:00'
                  calendar_event_end_time:
                    type: string
                    example: '15:00'
                  person_ids:
                    type: array
                    items:
                      type: integer
      requestBody:
        content:
          application/json:
            schema:
              type: object
              properties:
                activity:
                  type: object
                  properties:
                    activity_result_id:
                      type: integer
                    activity_type_id:
                      type: integer
                    completed_at:
                      type: string
                      format: date-time
                      description: If null, activity is scheduled to be performed
                    direction:
                      type: string
                      description: One of 'inbound' or 'outbound'
                    notes:
                      type: string
                      description: |
                        Can include basic HTML. Allowed elements:
                        <code>
                        a abbr acronym address b big blockquote br cite code dd del dfn div dl dt em h1 h2 h3 h4 h5 h6 hr i img ins kbd li mark ol p pre samp small span strong sub sup time tt ul var
                        </code>
                    pinned:
                      type: boolean
                      description: |
                        Pinned activities are pinned to the top of the completed
                        activities list that users see. They are also displayed
                        along with the life story.
                    sales_counselor_id:
                      type: integer
                    scheduled_at:
                      type: string
                      format: date-time
                      description: 'Note: users only see the scheduled date, not the
                        time.

                        '
                    add_to_calendar:
                      type: boolean
                      description: |
                        If true, time_zone, calendar_event_start_time, and
                        calendar_event_end_time will be required
                    time_zone:
                      type: string
                      nullable: false
                      example: Eastern Time (US & Canada)
                      description: |
                        The standard North American time zones are:
                        ["Eastern Time (US & Canada)", "Central Time (US & Canada)", "Mountain Time (US & Canada)", "Pacific Time (US & Canada)", "Alaska", "Arizona", "Hawaii"]
                    calendar_event_start_time:
                      type: string
                      example: '14:00'
                      description: |
                        Supports both military time and 12-hour time with Meridian indicators
                        like "2:00 PM"
                    calendar_event_end_time:
                      type: string
                      example: '15:00'
                      description: |
                        Supports both military time and 12-hour time with Meridian indicators
                        like "3:00 PM"
                    person_ids:
                      type: array
                      items:
                        type: integer
                      description: 'A list of person IDs of any people included in
                        the activity

                        '
  "/activity_results":
    get:
      summary: List Activity Results
      tags:
      - Activities
      responses:
        '200':
          description: list activity results
          content:
            application/json:
              schema:
                type: array
                items:
                  type: object
                  properties:
                    id:
                      type: integer
                    name:
                      type: string
                    successful:
                      type: boolean
                    discarded_at:
                      type: string
                      format: date-time
                      nullable: true
                    created_at:
                      type: string
                      format: date-time
                    updated_at:
                      type: string
                      format: date-time
  "/activity_types":
    get:
      summary: List Activity Types
      tags:
      - Activities
      responses:
        '200':
          description: list activity types
          content:
            application/json:
              schema:
                type: array
                items:
                  type: object
                  properties:
                    id:
                      type: integer
                    account_id:
                      type: integer
                    name:
                      type: string
                      example: Tour
                    created_at:
                      type: string
                      format: date-time
                    updated_at:
                      type: string
                      format: date-time
  "/care_types":
    get:
      summary: List Care Types
      tags:
      - Care Types
      responses:
        '200':
          description: list care types
          content:
            application/json:
              schema:
                type: array
                items:
                  type: object
                  properties:
                    id:
                      type: integer
                    name:
                      type: string
                      example: Assisted Living
                    abbreviation:
                      type: string
                      example: AL
                    created_at:
                      type: string
                      format: date-time
                    updated_at:
                      type: string
                      format: date-time
  "/close_reasons":
    get:
      summary: List Close Reasons
      tags:
      - Close Reasons
      responses:
        '200':
          description: list close reasons
          content:
            application/json:
              schema:
                type: array
                items:
                  type: object
                  properties:
                    id:
                      type: integer
                    name:
                      type: string
                    details_type:
                      type: string
                      enum:
                      - none
                      - free_text
                      - dropdown
                    details_description:
                      type: string
                      nullable: true
                    deceased_close_reason:
                      type: boolean
                    discarded_at:
                      type: string
                      format: date-time
                      nullable: true
                    created_at:
                      type: string
                      format: date-time
                    updated_at:
                      type: string
                      format: date-time
  "/communities":
    get:
      summary: List Communities
      tags:
      - Communities
      responses:
        '200':
          description: list communities
          content:
            application/json:
              schema:
                type: array
                items:
                  type: object
                  properties:
                    id:
                      type: integer
                    name:
                      type: string
                      example: Community Name
                    created_at:
                      type: string
                      format: date-time
                    updated_at:
                      type: string
                      format: date-time
  "/events":
    get:
      summary: List Events
      tags:
      - Events
      parameters:
      - name: limit
        in: query
        required: false
        description: |
          Numbers of records to return per page.
          See response details below to learn about pagination.
          Default: `10`.
          Maximum: `100`.
        schema:
          type: integer
      - name: filters[community_id]
        in: query
        required: false
        example: 1
        schema:
          type: integer
      - name: filters[created_at_after]
        in: query
        required: false
        example: '2000-01-01T00:00:00Z'
        schema:
          type: string
      - name: filters[created_at_before]
        in: query
        required: false
        example: '2000-01-01T00:00:00Z'
        schema:
          type: string
      - name: filters[updated_at_after]
        in: query
        required: false
        example: '2000-01-01T00:00:00Z'
        schema:
          type: string
      - name: filters[updated_at_before]
        in: query
        required: false
        example: '2000-01-01T00:00:00Z'
        schema:
          type: string
      responses:
        '200':
          description: ok
          headers:
            Link:
              type: string
              description: |
                If the response has been paginated and there are more records to
                retrieve, the "Link" header will be present with a URL that can be used to
                fetch the next page.

                E.g., `Link: <https://crm.welcomehomesoftware.com/api/path/to/endpoint?cursor=6eb0d8c2e74cedf3>; rel="next"`

                Note: a given cursor can only be used 3 times within a single minute, a
                limit imposed to mitigate infinitely pulling the same page.
          content:
            application/json:
              schema:
                type: array
                items:
                  type: object
                  properties:
                    id:
                      type: integer
                    community_id:
                      type: integer
                      required: true
                    name:
                      type: string
                      required: true
                    host_id:
                      type: integer
                      required: true
                      description: User ID of the event's host
                    date:
                      type: string
                      description: 'e.g., "1/31/2000" or "2000-01-31" '
                      example: 1/31/2000
                    start_time:
                      type: string
                      example: '14:00'
                      description: |
                        Supports both military time and 12-hour time with Meridian indicators
                        like "2:00 PM"
                    end_time:
                      type: string
                      example: '15:00'
                      description: |
                        Supports both military time and 12-hour time with Meridian indicators
                        like "3:00 PM"
                    time_zone:
                      type: string
                      nullable: false
                      example: Eastern Time (US & Canada)
                      description: |
                        The standard North American time zones are:
                        ["Eastern Time (US & Canada)", "Central Time (US & Canada)", "Mountain Time (US & Canada)", "Pacific Time (US & Canada)", "Alaska", "Arizona", "Hawaii"]
                    location:
                      type: string
                      example: Morningside of Bellaire
                      description: Defaults to the Community's name
                    address:
                      type: string
                      example: 123 Main St, NY, NY
                      description: Defaults to the Community's address
                    budget:
                      type: decimal
                      example: 2200.5
                    total_cost:
                      type: decimal
                      example: 2100.0
                    created_at:
                      type: string
                      format: date-time
                    updated_at:
                      type: string
                      format: date-time
    post:
      summary: Create Event
      tags:
      - Events
      parameters: []
      responses:
        '201':
          description: created
          content:
            application/json:
              schema:
                type: object
                properties:
                  id:
                    type: integer
                  community_id:
                    type: integer
                    required: true
                  name:
                    type: string
                    required: true
                  host_id:
                    type: integer
                    required: true
                    description: User ID of the event's host
                  date:
                    type: string
                    description: 'e.g., "1/31/2000" or "2000-01-31" '
                    example: 1/31/2000
                  start_time:
                    type: string
                    example: '14:00'
                    description: |
                      Supports both military time and 12-hour time with Meridian indicators
                      like "2:00 PM"
                  end_time:
                    type: string
                    example: '15:00'
                    description: |
                      Supports both military time and 12-hour time with Meridian indicators
                      like "3:00 PM"
                  time_zone:
                    type: string
                    nullable: false
                    example: Eastern Time (US & Canada)
                    description: |
                      The standard North American time zones are:
                      ["Eastern Time (US & Canada)", "Central Time (US & Canada)", "Mountain Time (US & Canada)", "Pacific Time (US & Canada)", "Alaska", "Arizona", "Hawaii"]
                  location:
                    type: string
                    example: Morningside of Bellaire
                    description: Defaults to the Community's name
                  address:
                    type: string
                    example: 123 Main St, NY, NY
                    description: Defaults to the Community's address
                  budget:
                    type: decimal
                    example: 2200.5
                  total_cost:
                    type: decimal
                    example: 2100.0
                  created_at:
                    type: string
                    format: date-time
                  updated_at:
                    type: string
                    format: date-time
      requestBody:
        content:
          application/json:
            schema:
              type: object
              properties:
                event:
                  type: object
                  properties:
                    community_id:
                      type: integer
                      required: true
                    name:
                      type: string
                      required: true
                    host_id:
                      type: integer
                      required: true
                      description: User ID of the event's host
                    date:
                      type: string
                      description: 'e.g., "1/31/2000" or "2000-01-31" '
                      example: 1/31/2000
                    start_time:
                      type: string
                      example: '14:00'
                      description: |
                        Supports both military time and 12-hour time with Meridian indicators
                        like "2:00 PM"
                    end_time:
                      type: string
                      example: '15:00'
                      description: |
                        Supports both military time and 12-hour time with Meridian indicators
                        like "3:00 PM"
                    time_zone:
                      type: string
                      nullable: false
                      example: Eastern Time (US & Canada)
                      description: |
                        The standard North American time zones are:
                        ["Eastern Time (US & Canada)", "Central Time (US & Canada)", "Mountain Time (US & Canada)", "Pacific Time (US & Canada)", "Alaska", "Arizona", "Hawaii"]
                    location:
                      type: string
                      example: Morningside of Bellaire
                      description: Defaults to the Community's name
                    address:
                      type: string
                      example: 123 Main St, NY, NY
                      description: Defaults to the Community's address
                    budget:
                      type: decimal
                      example: 2200.5
                    total_cost:
                      type: decimal
                      example: 2100.0
                  required:
                  - community_id
                  - name
                  - host_id
  "/events/{event_id}/rsvps":
    post:
      summary: RSVP to an Event
      tags:
      - Events
      description: |
        This endpoint updates an RSVP status of an invite that corresponds to a
        person's email or ID, for the given event.

        Either an email or a person ID is required.

        If both an email and a person ID are present, only the person ID will be
        used. If the email is used for multiple people who are invited to the
        event, all of the corresponding invites will be updated to the given
        status.

        If an email or a person ID for an uninvited person is submitted, then that
        person's Prospect or Referrer record will be invited to the event, and the
        invite that corresponds to the submitted email or ID will be updated to the
        given status.

        All people with an invite to the corresponding event that match the
        provided email address will be updated to the same status.

        If an email or person ID is submitted that does not exist, this endpoint
        returns a 404 response.

        If no status parameter or neither email or person ID parameters are
        submitted, this endpoint returns a 422 response.
      parameters:
      - name: event_id
        description: An event ID
        in: path
        required: true
        schema:
          type: integer
      responses:
        '200':
          description: success
        '404':
          description: not_found
        '422':
          description: unprocessable_entity
      requestBody:
        content:
          application/json:
            schema:
              type: object
              properties:
                email:
                  type: string
                status:
                  type: string
                  enum:
                  - pending_response
                  - accepted
                  - declined
                  - not_sure
                person_id:
                  type: integer
              required:
              - status
  "/exports/community/{community_id}/table/{table}":
    get:
      summary: Live, paginated CSV data
      tags:
      - Exports
      description: |
        This endpoint provides live, paginated bulk export capability.

        This endpoint is the most efficient way to get a full data dump out of
        WelcomeHome. It can also be used to poll for changes by filtering based on
        `updated_at`.

        For example, a common strategy used to maintain an up-to-date copy of
        WelcomeHome's data is to:

        - Perform an initial pull of each table, paging through all results to get
        an entire copy of the dataset

        - Periodically re-poll, but using `updated_at_after` to retrieve any
        changes made since the last poll.

        By default, this endpoint returns 1000
        results per page. To retrieve all data, be sure to request each page until
        all pages have been fetched.

        If the response has been paginated and there are more records to
        retrieve, the "Link" header will be present with a URL that can be used to
        fetch the next page.

        E.g., `Link: <https://crm.welcomehomesoftware.com/api/path/to/endpoint?cursor=6eb0d8c2e74cedf3>; rel="next"`

        Note: a given cursor can only be used 3 times within a single minute, a
        limit imposed to mitigate infinitely pulling the same page.


        All timestamps are in UTC unless otherwise specified.
      parameters:
      - name: community_id
        description: A community ID or `all` for all communities
        in: path
        required: true
        schema:
          type: string
      - name: table
        description: |
          The table to export. One of:
          - Organizations
          - Referrers
          - Prospects
          - ProspectFields
          - ReferrerFields
          - Residents
          - Influencers
          - Activities
          - ExternalReferences
          - Units
          - HousingContracts
          - DepositTransactions
          - MarketingTouchpoints
          - ServiceAgreements
          - Traits
          - Users
          - WaitlistEntries

          Note the capitalization of the table names. The values are case-sensitive
        in: path
        required: true
        schema:
          type: string
      - name: sort_by
        description: |
          Column to sort by:
          - `updated_at` (default)
          - `created_at`
        in: query
        required: false
        schema:
          type: string
      - name: limit
        in: query
        required: false
        description: |
          Numbers of records to return per page.
          See response details below to learn about pagination.
          Default: `1000`.
          Maximum: `10000`.
        schema:
          type: integer
      - name: filters[created_at_after]
        in: query
        required: false
        example: '2000-01-01T00:00:00Z'
        schema:
          type: string
      - name: filters[created_at_before]
        in: query
        required: false
        example: '2000-01-01T00:00:00Z'
        schema:
          type: string
      - name: filters[updated_at_after]
        in: query
        required: false
        example: '2000-01-01T00:00:00Z'
        schema:
          type: string
      - name: filters[updated_at_before]
        in: query
        required: false
        example: '2000-01-01T00:00:00Z'
        schema:
          type: string
      responses:
        '200':
          description: CSV (expand to read about pagination)
          headers:
            Link:
              type: string
              description: |
                If the response has been paginated and there are more records to
                retrieve, the "Link" header will be present with a URL that can be used to
                fetch the next page.

                E.g., `Link: <https://crm.welcomehomesoftware.com/api/path/to/endpoint?cursor=6eb0d8c2e74cedf3>; rel="next"`

                Note: a given cursor can only be used 3 times within a single minute, a
                limit imposed to mitigate infinitely pulling the same page.
  "/exports/daily_snapshots/table/{table}":
    get:
      summary: Daily snapshot of CSV data
      tags:
      - Exports
      description: |
        This endpoint provides access to unpaginated, daily snapshots of the
        same content that can be retrieved from the live, paginated export
        endpoint.

        The snapshots are generated nightly. In order to use this endpoint,
        please contact support@welcomehomesoftware.com to ask for the daily
        snapshot export endpoint to be activated.

        This endpoint may be a better choice for Business Intelligence (BI)
        integrations in which:

        - Daily frequency is sufficient
        - Pagination is difficult or cumbersome

        Requires an API Token with access to all communities

        All timestamps are in UTC unless otherwise specified.
      parameters:
      - name: table
        description: |
          The table to export. One of:
          - Organizations
          - Referrers
          - Prospects
          - ProspectFields
          - ReferrerFields
          - Residents
          - Influencers
          - Activities
          - ExternalReferences
          - Units
          - HousingContracts
          - DepositTransactions
          - MarketingTouchpoints
          - ServiceAgreements
          - Traits
          - Users
          - WaitlistEntries

          Note the capitalization of the table names. The values are case-sensitive
        in: path
        required: true
        schema:
          type: string
      - name: direct
        description: |
          Set to `true` to receive the file content directly instead of a
          redirect.

          By default, this endpoint redirects to a signed S3 URL, which is the
          most efficient approach. However, some clients (such as Azure Data
          Factory) cannot follow HTTP redirects. For these clients,
          `direct=true` streams the file through our servers instead.

          Note: We suggest only using the direct option if necessary.
        in: query
        required: false
        schema:
          type: string
      responses:
        '301':
          description: Redirect to CSV location (default)
        '200':
          description: CSV content (when direct=true)
  "/floor_plans":
    get:
      summary: List Floor Plans
      tags:
      - Floor Plans
      parameters:
      - name: filters[community_id]
        in: query
        required: false
        example: '1'
        schema:
          type: integer
      responses:
        '200':
          description: list floor plans
          content:
            application/json:
              schema:
                type: array
                items:
                  type: object
                  properties:
                    id:
                      type: integer
                    community_id:
                      type: integer
                    name:
                      type: string
                    square_feet:
                      type: integer
                    beds:
                      type: integer
                    baths:
                      type: decimal
                    occupancy_points:
                      type: decimal
                    default_privacy_level_id:
                      type: integer
                    created_at:
                      type: string
                      format: date-time
                    updated_at:
                      type: string
                      format: date-time
  "/housing_contracts":
    get:
      summary: List Housing Contracts
      tags:
      - HousingContracts
      parameters:
      - name: limit
        in: query
        required: false
        description: |
          Numbers of records to return per page.
          See response details below to learn about pagination.
          Default: `10`.
          Maximum: `100`.
        schema:
          type: integer
      - name: filters[created_at_after]
        in: query
        required: false
        example: '2000-01-01T00:00:00Z'
        schema:
          type: string
      - name: filters[created_at_before]
        in: query
        required: false
        example: '2000-01-01T00:00:00Z'
        schema:
          type: string
      - name: filters[updated_at_after]
        in: query
        required: false
        example: '2000-01-01T00:00:00Z'
        schema:
          type: string
      - name: filters[updated_at_before]
        in: query
        required: false
        example: '2000-01-01T00:00:00Z'
        schema:
          type: string
      - name: filters[move_in_date_before]
        in: query
        required: false
        example: '2000-01-01'
        schema:
          type: string
      - name: filters[move_in_date_after]
        in: query
        required: false
        example: '2000-01-01'
        schema:
          type: string
      - name: filters[prospect_id]
        in: query
        required: false
        example: 1
        schema:
          type: integer
      - name: filters[resident_id]
        in: query
        required: false
        example: 1
        schema:
          type: integer
      - name: filters[community_id]
        in: query
        required: false
        example: 1
        schema:
          type: integer
      responses:
        '200':
          description: list housing contracts
          headers:
            Link:
              type: string
              description: |
                If the response has been paginated and there are more records to
                retrieve, the "Link" header will be present with a URL that can be used to
                fetch the next page.

                E.g., `Link: <https://crm.welcomehomesoftware.com/api/path/to/endpoint?cursor=6eb0d8c2e74cedf3>; rel="next"`

                Note: a given cursor can only be used 3 times within a single minute, a
                limit imposed to mitigate infinitely pulling the same page.
          content:
            application/json:
              schema:
                type: array
                items:
                  type: object
                  properties:
                    id:
                      type: integer
                    community_id:
                      type: integer
                    unit_id:
                      type: integer
                    move_in_date:
                      type: datetime
                    move_out_date:
                      type: datetime
                    financial_move_in_date:
                      type: date
                    financial_move_out_date:
                      type: date
                    created_at:
                      type: string
                      format: date-time
                    updated_at:
                      type: string
                      format: date-time
                    move_out_reason_id:
                      type: integer
                    monthly_rate:
                      type: integer
                    recurring_concession:
                      type: integer
                    one_time_concession:
                      type: integer
                    sales_counselor_id:
                      type: integer
                    notice_given_date:
                      type: datetime
                    deposit_received_on:
                      type: datetime
                    deposit_amount:
                      type: integer
                    occupancy_point_factor:
                      type: integer
                    community_fee_amount:
                      type: integer
                    community_fee_received_on:
                      type: datetime
                    risk_level:
                      type: integer
                    transfer_from_id:
                      type: integer
                    count_move_in:
                      type: boolean
                    count_move_out:
                      type: boolean
                    stay_type:
                      enum:
                      - permanent
                      - respite
                      - day
                      type: string
                    concession_description:
                      type: string
                    privacy_level_id:
                      type: integer
                    privacy_level_variant:
                      type: string
                      example: A
                    move_out_reason_details:
                      type: string
                    resident_count_override:
                      type: integer
                    leased_on:
                      type: datetime
                    lease_canceled_on:
                      type: datetime
                    prospect_ids:
                      type: array
                      items:
                        type: integer
                    resident_ids:
                      type: array
                      items:
                        type: integer
                    status:
                      enum:
                      - future
                      - notice
                      - prior
                      - current
                      - canceled
                      type: string
                    housing_contract_field_values_attributes:
                      type: array
                      items:
                        type: object
                        properties:
                          id:
                            type: integer
                          housing_contract_field_id:
                            type: integer
                          housing_contract_field_name:
                            type: string
                          value:
                            oneOf:
                            - type: string
                            - type: array
                              items:
                                type: string
                            description: |
                              Values must be formatted appropriately for the given field type:

                              - `amount`: a number with optional decimals (e.g., "100" or "100.12")
                              - `date`: DD/MM/YYYY (e.g., "1/1/2001" or "01/01/2001")
                              - `checkbox`: "0" for unchecked, "1" for checked
                              - `single_line_text`: a string with no newlines
                              - `paragraph`: a string that may contain newlines
                              - `multi_select_list`: an array of strings
                              - `single_select_list`: a string
    post:
      summary: Create Housing Contract
      tags:
      - HousingContracts
      parameters: []
      responses:
        '201':
          description: created
          content:
            application/json:
              schema:
                type: object
                properties:
                  id:
                    type: integer
                  community_id:
                    type: integer
                  unit_id:
                    type: integer
                  move_in_date:
                    type: datetime
                  move_out_date:
                    type: datetime
                  financial_move_in_date:
                    type: date
                  financial_move_out_date:
                    type: date
                  created_at:
                    type: string
                    format: date-time
                  updated_at:
                    type: string
                    format: date-time
                  move_out_reason_id:
                    type: integer
                  monthly_rate:
                    type: integer
                  recurring_concession:
                    type: integer
                  one_time_concession:
                    type: integer
                  sales_counselor_id:
                    type: integer
                  notice_given_date:
                    type: datetime
                  deposit_received_on:
                    type: datetime
                  deposit_amount:
                    type: integer
                  occupancy_point_factor:
                    type: integer
                  community_fee_amount:
                    type: integer
                  community_fee_received_on:
                    type: datetime
                  risk_level:
                    type: integer
                  transfer_from_id:
                    type: integer
                  count_move_in:
                    type: boolean
                  count_move_out:
                    type: boolean
                  stay_type:
                    enum:
                    - permanent
                    - respite
                    - day
                    type: string
                  concession_description:
                    type: string
                  privacy_level_id:
                    type: integer
                  privacy_level_variant:
                    type: string
                    example: A
                  move_out_reason_details:
                    type: string
                  resident_count_override:
                    type: integer
                  leased_on:
                    type: datetime
                  lease_canceled_on:
                    type: datetime
                  prospect_ids:
                    type: array
                    items:
                      type: integer
                  resident_ids:
                    type: array
                    items:
                      type: integer
                  status:
                    enum:
                    - future
                    - notice
                    - prior
                    - current
                    - canceled
                    type: string
                  housing_contract_field_values_attributes:
                    type: array
                    items:
                      type: object
                      properties:
                        id:
                          type: integer
                        housing_contract_field_id:
                          type: integer
                        housing_contract_field_name:
                          type: string
                        value:
                          oneOf:
                          - type: string
                          - type: array
                            items:
                              type: string
                          description: |
                            Values must be formatted appropriately for the given field type:

                            - `amount`: a number with optional decimals (e.g., "100" or "100.12")
                            - `date`: DD/MM/YYYY (e.g., "1/1/2001" or "01/01/2001")
                            - `checkbox`: "0" for unchecked, "1" for checked
                            - `single_line_text`: a string with no newlines
                            - `paragraph`: a string that may contain newlines
                            - `multi_select_list`: an array of strings
                            - `single_select_list`: a string
        '422':
          description: unprocessable_entity
          content:
            application/json:
              schema:
                type: object
                properties:
                  errors:
                    type: object
                    example:
                      one_time_concession:
                      - must be greater than or equal to 0
      requestBody:
        content:
          application/json:
            schema:
              type: object
              properties:
                housing_contract:
                  type: object
                  properties:
                    community_id:
                      type: integer
                    unit_id:
                      type: integer
                    resident_ids:
                      type: array
                      items:
                        type: integer
                    move_in_date:
                      type: datetime
                    financial_move_in_date:
                      type: date
                    move_out_date:
                      type: datetime
                    financial_move_out_date:
                      type: date
                    notice_given_date:
                      type: datetime
                    leased_on:
                      type: datetime
                    lease_canceled_on:
                      type: datetime
                    move_out_reason_id:
                      type: integer
                    move_out_reason_details:
                      type: string
                    privacy_level_id:
                      type: integer
                    privacy_level_variant:
                      type: string
                      example: A
                    sales_counselor_id:
                      type: integer
                    stay_type:
                      enum:
                      - permanent
                      - respite
                      - day
                      type: string
                    monthly_rate:
                      type: integer
                    one_time_concession:
                      type: integer
                    recurring_concession:
                      type: integer
                    concession_description:
                      type: string
                    resident_count_override:
                      type: integer
                    count_move_in:
                      type: boolean
                    count_move_out:
                      type: boolean
                  required:
                  - community_id
                  - unit_id
                  - resident_ids
  "/housing_contracts/{id}":
    put:
      summary: Update Housing Contract
      tags:
      - HousingContracts
      parameters:
      - name: id
        in: path
        required: true
        schema:
          type: integer
      responses:
        '200':
          description: ok
          content:
            application/json:
              schema:
                type: object
                properties:
                  id:
                    type: integer
                  community_id:
                    type: integer
                  unit_id:
                    type: integer
                  move_in_date:
                    type: datetime
                  move_out_date:
                    type: datetime
                  financial_move_in_date:
                    type: date
                  financial_move_out_date:
                    type: date
                  created_at:
                    type: string
                    format: date-time
                  updated_at:
                    type: string
                    format: date-time
                  move_out_reason_id:
                    type: integer
                  monthly_rate:
                    type: integer
                  recurring_concession:
                    type: integer
                  one_time_concession:
                    type: integer
                  sales_counselor_id:
                    type: integer
                  notice_given_date:
                    type: datetime
                  deposit_received_on:
                    type: datetime
                  deposit_amount:
                    type: integer
                  occupancy_point_factor:
                    type: integer
                  community_fee_amount:
                    type: integer
                  community_fee_received_on:
                    type: datetime
                  risk_level:
                    type: integer
                  transfer_from_id:
                    type: integer
                  count_move_in:
                    type: boolean
                  count_move_out:
                    type: boolean
                  stay_type:
                    enum:
                    - permanent
                    - respite
                    - day
                    type: string
                  concession_description:
                    type: string
                  privacy_level_id:
                    type: integer
                  privacy_level_variant:
                    type: string
                    example: A
                  move_out_reason_details:
                    type: string
                  resident_count_override:
                    type: integer
                  leased_on:
                    type: datetime
                  lease_canceled_on:
                    type: datetime
                  prospect_ids:
                    type: array
                    items:
                      type: integer
                  resident_ids:
                    type: array
                    items:
                      type: integer
                  status:
                    enum:
                    - future
                    - notice
                    - prior
                    - current
                    - canceled
                    type: string
                  housing_contract_field_values_attributes:
                    type: array
                    items:
                      type: object
                      properties:
                        id:
                          type: integer
                        housing_contract_field_id:
                          type: integer
                        housing_contract_field_name:
                          type: string
                        value:
                          oneOf:
                          - type: string
                          - type: array
                            items:
                              type: string
                          description: |
                            Values must be formatted appropriately for the given field type:

                            - `amount`: a number with optional decimals (e.g., "100" or "100.12")
                            - `date`: DD/MM/YYYY (e.g., "1/1/2001" or "01/01/2001")
                            - `checkbox`: "0" for unchecked, "1" for checked
                            - `single_line_text`: a string with no newlines
                            - `paragraph`: a string that may contain newlines
                            - `multi_select_list`: an array of strings
                            - `single_select_list`: a string
        '422':
          description: unprocessable_entity
          content:
            application/json:
              schema:
                type: object
                properties:
                  errors:
                    type: object
                    example:
                      one_time_concession:
                      - must be greater than or equal to 0
      requestBody:
        content:
          application/json:
            schema:
              type: object
              properties:
                housing_contract:
                  type: object
                  properties:
                    unit_id:
                      type: integer
                    resident_ids:
                      type: array
                      items:
                        type: integer
                    move_in_date:
                      type: datetime
                    financial_move_in_date:
                      type: date
                    move_out_date:
                      type: datetime
                    financial_move_out_date:
                      type: date
                    notice_given_date:
                      type: datetime
                    leased_on:
                      type: datetime
                    lease_canceled_on:
                      type: datetime
                    move_out_reason_id:
                      type: integer
                    move_out_reason_details:
                      type: string
                    privacy_level_id:
                      type: integer
                    privacy_level_variant:
                      type: string
                      example: A
                    sales_counselor_id:
                      type: integer
                    stay_type:
                      enum:
                      - permanent
                      - respite
                      - day
                      type: string
                    monthly_rate:
                      type: integer
                    one_time_concession:
                      type: integer
                    recurring_concession:
                      type: integer
                    concession_description:
                      type: string
                    resident_count_override:
                      type: integer
                    count_move_in:
                      type: boolean
                    count_move_out:
                      type: boolean
  "/influencers/{id}":
    get:
      summary: Show Influencer
      tags:
      - Influencers
      parameters:
      - name: id
        in: path
        required: true
        schema:
          type: integer
      responses:
        '200':
          description: success
          content:
            application/json:
              schema:
                type: object
                properties:
                  id:
                    type: integer
                  decision_maker:
                    type: boolean
                  health_care_proxy:
                    type: boolean
                  person_attributes:
                    properties:
                      id:
                        type: integer
                      first_name:
                        type: string
                        nullable: true
                      middle_name:
                        type: string
                        nullable: true
                      last_name:
                        type: string
                        nullable: true
                      cell_phone:
                        type: string
                        nullable: true
                      home_phone:
                        type: string
                        nullable: true
                      work_phone:
                        type: string
                        nullable: true
                      email:
                        type: string
                        nullable: true
                      fax_number:
                        type: string
                        nullable: true
                      do_not_call:
                        type: boolean
                        default: false
                      do_not_email:
                        type: boolean
                        default: false
                      do_not_mail:
                        type: boolean
                        default: false
                      do_not_text:
                        type: boolean
                        default: false
                      birthdate:
                        type: string
                        nullable: true
                      provided_age:
                        type: integer
                        nullable: true
                      gender:
                        type: string
                        enum:
                        - male
                        - female
                        nullable: true
                      address_attributes:
                        type: object
                        properties:
                          line1:
                            type: string
                            nullable: true
                          line2:
                            type: string
                            nullable: true
                          city:
                            type: string
                            nullable: true
                          state:
                            type: string
                            nullable: true
                          zip:
                            type: string
                            nullable: true
                    type: object
                  point_of_contact:
                    type: boolean
                  power_of_attorney:
                    type: boolean
                  notes:
                    type: string
                  relationship_id:
                    type: integer
    put:
      summary: Update Influencer
      tags:
      - Influencers
      description: |
        The influencers endpoint allows you to update certain data points for
        influencers in WelcomeHome.

        The permitted data points relate to birthdate, age, gender, and address.
      parameters: []
      responses:
        '200':
          description: success
          content:
            application/json:
              schema:
                type: object
                properties:
                  id:
                    type: integer
                  decision_maker:
                    type: boolean
                  health_care_proxy:
                    type: boolean
                  person_attributes:
                    properties:
                      id:
                        type: integer
                      first_name:
                        type: string
                        nullable: true
                      middle_name:
                        type: string
                        nullable: true
                      last_name:
                        type: string
                        nullable: true
                      cell_phone:
                        type: string
                        nullable: true
                      home_phone:
                        type: string
                        nullable: true
                      work_phone:
                        type: string
                        nullable: true
                      email:
                        type: string
                        nullable: true
                      fax_number:
                        type: string
                        nullable: true
                      do_not_call:
                        type: boolean
                        default: false
                      do_not_email:
                        type: boolean
                        default: false
                      do_not_mail:
                        type: boolean
                        default: false
                      do_not_text:
                        type: boolean
                        default: false
                      birthdate:
                        type: string
                        nullable: true
                      provided_age:
                        type: integer
                        nullable: true
                      gender:
                        type: string
                        enum:
                        - male
                        - female
                        nullable: true
                      address_attributes:
                        type: object
                        properties:
                          line1:
                            type: string
                            nullable: true
                          line2:
                            type: string
                            nullable: true
                          city:
                            type: string
                            nullable: true
                          state:
                            type: string
                            nullable: true
                          zip:
                            type: string
                            nullable: true
                    type: object
                  point_of_contact:
                    type: boolean
                  power_of_attorney:
                    type: boolean
                  notes:
                    type: string
                  relationship_id:
                    type: integer
        '422':
          description: unprocessable_entity
          content:
            application/json:
              schema:
                type: object
                properties:
                  errors:
                    type: object
                    example:
                      person.provided_age:
                      - must be less than 200
      requestBody:
        content:
          application/json:
            schema:
              type: object
              properties:
                influencer:
                  properties:
                    notes:
                      type: string
                    person_attributes:
                      type: object
                      properties:
                        first_name:
                          type: string
                          nullable: true
                        middle_name:
                          type: string
                          nullable: true
                        last_name:
                          type: string
                          nullable: true
                        cell_phone:
                          type: string
                          nullable: true
                        home_phone:
                          type: string
                          nullable: true
                        work_phone:
                          type: string
                          nullable: true
                        email:
                          type: string
                          nullable: true
                        fax_number:
                          type: string
                          nullable: true
                        do_not_call:
                          type: boolean
                          default: false
                        do_not_email:
                          type: boolean
                          default: false
                        do_not_mail:
                          type: boolean
                          default: false
                        do_not_text:
                          type: boolean
                          default: false
                        birthdate:
                          type: string
                          nullable: true
                        provided_age:
                          type: integer
                          nullable: true
                        gender:
                          type: string
                          enum:
                          - male
                          - female
                          nullable: true
                        address_attributes:
                          type: object
                          properties:
                            line1:
                              type: string
                              nullable: true
                            line2:
                              type: string
                              nullable: true
                            city:
                              type: string
                              nullable: true
                            state:
                              type: string
                              nullable: true
                            zip:
                              type: string
                              nullable: true
                    relationship_id:
                      type: integer
  "/lead_sources":
    get:
      summary: List Lead Sources
      tags:
      - Lead Sources
      responses:
        '200':
          description: list lead sources
          content:
            application/json:
              schema:
                type: array
                items:
                  type: object
                  properties:
                    id:
                      type: integer
                    name:
                      type: string
                    category:
                      type: string
                    discarded_at:
                      type: string
                      format: date-time
                    created_at:
                      type: string
                      format: date-time
                    updated_at:
                      type: string
                      format: date-time
  "/move_out_reasons":
    get:
      summary: List Move Out Reasons
      tags:
      - Move Out Reasons
      responses:
        '200':
          description: list move out reasons
          content:
            application/json:
              schema:
                type: array
                items:
                  type: object
                  properties:
                    id:
                      type: integer
                    name:
                      type: string
                    system_reason:
                      type: string
                      enum:
                      - deceased
                      nullable: true
                    details_description:
                      type: string
                      nullable: true
                    discarded_at:
                      type: string
                      format: date-time
                      nullable: true
                    created_at:
                      type: string
                      format: date-time
                    updated_at:
                      type: string
                      format: date-time
  "/privacy_levels":
    get:
      summary: List Privacy Levels
      tags:
      - Privacy Levels
      parameters:
      - name: filters[community_id]
        in: query
        required: false
        example: '1'
        schema:
          type: integer
      responses:
        '200':
          description: list privacy levels
          content:
            application/json:
              schema:
                type: array
                items:
                  type: object
                  properties:
                    id:
                      type: integer
                    name:
                      type: string
                    community_id:
                      type: integer
                    exclude_second_residents_from_resident_count:
                      type: boolean
                    occupants:
                      type: integer
                      description: |
                        How many residents can occupancy this room. This value dictates how many
                        "occupancy points" each resident counts as. For example, if occupants is
                        2, then each resident counts of 0.5 occupancy points
                    second_resident_variant:
                      type: boolean
                      description: |
                        Whether this privacy level supports second residents. Second residents
                        do not impact occupancy points (i.e., they always count as 0 points)
                    second_resident_variant_show_a:
                      type: boolean
                      description: |
                        When `second_resident_variant`, whether the primary resident's unit
                        number has 'A' added as a suffix
                    created_at:
                      type: string
                      format: date-time
                    updated_at:
                      type: string
                      format: date-time
    post:
      summary: Create Privacy Level
      tags:
      - Privacy Levels
      parameters: []
      responses:
        '201':
          description: created
          content:
            application/json:
              schema:
                type: object
                properties:
                  id:
                    type: integer
                  name:
                    type: string
                  community_id:
                    type: integer
                  exclude_second_residents_from_resident_count:
                    type: boolean
                  occupants:
                    type: integer
                    description: |
                      How many residents can occupancy this room. This value dictates how many
                      "occupancy points" each resident counts as. For example, if occupants is
                      2, then each resident counts of 0.5 occupancy points
                  second_resident_variant:
                    type: boolean
                    description: |
                      Whether this privacy level supports second residents. Second residents
                      do not impact occupancy points (i.e., they always count as 0 points)
                  second_resident_variant_show_a:
                    type: boolean
                    description: |
                      When `second_resident_variant`, whether the primary resident's unit
                      number has 'A' added as a suffix
                  created_at:
                    type: string
                    format: date-time
                  updated_at:
                    type: string
                    format: date-time
        '404':
          description: not_found
          content:
            application/json:
              schema:
                type: object
                properties:
                  error:
                    type: string
        '422':
          description: unprocessable_entity
          content:
            application/json:
              schema:
                type: object
                properties:
                  errors:
                    type: object
                    example:
                      name:
                      - can't be blank
      requestBody:
        content:
          application/json:
            schema:
              type: object
              properties:
                privacy_level:
                  type: object
                  properties:
                    community_id:
                      type: integer
                    exclude_second_residents_from_resident_count:
                      type: boolean
                    name:
                      type: string
                    occupants:
                      type: integer
                      description: |
                        How many residents can occupancy this room. This value dictates how many
                        "occupancy points" each resident counts as. For example, if occupants is
                        2, then each resident counts of 0.5 occupancy points
                    second_resident_variant:
                      type: boolean
                      description: |
                        Whether this privacy level supports second residents. Second residents
                        do not impact occupancy points (i.e., they always count as 0 points)
                    second_resident_variant_show_a:
                      type: boolean
                      description: |
                        When `second_resident_variant`, whether the primary resident's unit
                        number has 'A' added as a suffix
                  required:
                  - community_id
                  - name
                  - occupants
              required:
              - privacy_level
        required: true
  "/privacy_levels/{id}":
    put:
      summary: Update Privacy Level
      tags:
      - Privacy Levels
      parameters:
      - name: id
        in: path
        required: true
        schema:
          type: integer
      responses:
        '200':
          description: ok
          content:
            application/json:
              schema:
                type: object
                properties:
                  id:
                    type: integer
                  name:
                    type: string
                  community_id:
                    type: integer
                  exclude_second_residents_from_resident_count:
                    type: boolean
                  occupants:
                    type: integer
                    description: |
                      How many residents can occupancy this room. This value dictates how many
                      "occupancy points" each resident counts as. For example, if occupants is
                      2, then each resident counts of 0.5 occupancy points
                  second_resident_variant:
                    type: boolean
                    description: |
                      Whether this privacy level supports second residents. Second residents
                      do not impact occupancy points (i.e., they always count as 0 points)
                  second_resident_variant_show_a:
                    type: boolean
                    description: |
                      When `second_resident_variant`, whether the primary resident's unit
                      number has 'A' added as a suffix
                  created_at:
                    type: string
                    format: date-time
                  updated_at:
                    type: string
                    format: date-time
        '404':
          description: not_found
          content:
            application/json:
              schema:
                type: object
                properties:
                  error:
                    type: string
        '422':
          description: unprocessable_entity
          content:
            application/json:
              schema:
                type: object
                properties:
                  errors:
                    type: object
                    example:
                      name:
                      - can't be blank
      requestBody:
        content:
          application/json:
            schema:
              type: object
              properties:
                privacy_level:
                  type: object
                  properties:
                    exclude_second_residents_from_resident_count:
                      type: boolean
                    name:
                      type: string
                    occupants:
                      type: integer
                      description: |
                        How many residents can occupancy this room. This value dictates how many
                        "occupancy points" each resident counts as. For example, if occupants is
                        2, then each resident counts of 0.5 occupancy points
                    second_resident_variant:
                      type: boolean
                      description: |
                        Whether this privacy level supports second residents. Second residents
                        do not impact occupancy points (i.e., they always count as 0 points)
                    second_resident_variant_show_a:
                      type: boolean
                      description: |
                        When `second_resident_variant`, whether the primary resident's unit
                        number has 'A' added as a suffix
              required:
              - privacy_level
        required: true
    delete:
      summary: Delete Privacy Level
      tags:
      - Privacy Levels
      parameters:
      - name: id
        in: path
        required: true
        schema:
          type: integer
      responses:
        '204':
          description: no_content
        '404':
          description: not_found
          content:
            application/json:
              schema:
                type: object
                properties:
                  error:
                    type: string
        '422':
          description: unprocessable_entity
          content:
            application/json:
              schema:
                type: object
                properties:
                  error:
                    type: string
  "/prospect_fields":
    get:
      summary: List Prospect Fields
      tags:
      - Prospect Fields
      responses:
        '200':
          description: list prospect fields
          content:
            application/json:
              schema:
                type: array
                items:
                  type: object
                  properties:
                    id:
                      type: integer
                    name:
                      type: string
                    field_type:
                      type: string
                      enum:
                      - amount
                      - date
                      - checkbox
                      - single_line_text
                      - paragraph
                      - multi_select_list
                      - single_select_list
                    position:
                      type: integer
                    required:
                      type: boolean
                    show_on_prospect_profile:
                      type: boolean
                    list_options:
                      type: array
                      items:
                        type: string
                    created_at:
                      type: string
                      format: date-time
                    updated_at:
                      type: string
                      format: date-time
  "/prospect_fields/{id}":
    put:
      summary: Update Prospect Field
      tags:
      - Prospect Fields
      description: |
        Updates a Prospect Field's name, position, required setting, and
        profile visibility.
        For list fields, list_options replaces the complete configured option
        list in the submitted order. Omit list_options to leave the configured
        options unchanged.
      parameters:
      - name: id
        in: path
        required: true
        schema:
          type: integer
      responses:
        '200':
          description: update prospect field
          content:
            application/json:
              schema:
                type: object
                properties:
                  id:
                    type: integer
                  name:
                    type: string
                  field_type:
                    type: string
                    enum:
                    - amount
                    - date
                    - checkbox
                    - single_line_text
                    - paragraph
                    - multi_select_list
                    - single_select_list
                  position:
                    type: integer
                  required:
                    type: boolean
                  show_on_prospect_profile:
                    type: boolean
                  list_options:
                    type: array
                    items:
                      type: string
                  created_at:
                    type: string
                    format: date-time
                  updated_at:
                    type: string
                    format: date-time
        '422':
          description: list options are not applicable
          content:
            application/json:
              schema:
                type: object
                properties:
                  errors:
                    type: object
                    example:
                      list_options:
                      - are only available for list fields
      requestBody:
        content:
          application/json:
            schema:
              type: object
              properties:
                prospect_field:
                  type: object
                  properties:
                    name:
                      type: string
                    position:
                      type: integer
                    required:
                      type: boolean
                    show_on_prospect_profile:
                      type: boolean
                    list_options:
                      type: array
                      items:
                        type: string
                      description: Only available for list fields
  "/prospects":
    post:
      summary: Create Prospect
      tags:
      - Prospects
      description: |
        The prospects endpoint allows you to add new prospects into WelcomeHome.

        When you add a new prospect, it appear on top of a new prospects
        dashboard. We also send notifications to users via email / mobile push as
        per their preferences.

        A prospect record must have at least one influencer or resident. And at
        least one of those records must have a first or last name. All other
        field are optional and should be omitted if intended to be left blank.
      parameters: []
      responses:
        '201':
          description: Create a prospect
          content:
            application/json:
              schema:
                type: object
                properties:
                  account_id:
                    type: integer
                  active_at:
                    type: string
                    format: date-time
                  close_reason_details:
                    type: string
                  close_reason_id:
                    type: integer
                  community_id:
                    type: integer
                  created_at:
                    type: string
                    format: date-time
                  discarded_at:
                    type: string
                    format: date-time
                  discarded_by_id:
                    type: integer
                  expected_move_timing_id:
                    type: integer
                  id:
                    type: integer
                  initial_contact_at:
                    type: string
                    format: date-time
                  last_contact_at:
                    type: string
                    format: date-time
                  lead_source_id:
                    type: integer
                  metadata:
                    description: |
                      This field stores any arbitrary JSON. It is commonly used to track
                      detailed marketing information e.g., UTM parameters and similar tracking
                      datapoints.

                      The metadata is included whenever Prospects are retrieved via the API,
                      including the Export endpoints. The metadata is intended to be consumed
                      by your BI tool.

                      The maximum allowed size of the metadata JSON is 4kB.
                    example:
                      utm_campaign: campaign-1
                      utm_term: senior living
                    type: object
                  merged_into_prospect_id:
                    type: integer
                  next_activity_scheduled_at:
                    type: string
                    format: date-time
                  original_sales_counselor_id:
                    type: integer
                  referrer_id:
                    type: integer
                  sales_counselor_id:
                    type: integer
                  score_id:
                    type: integer
                  secondary_lead_source_id:
                    type: integer
                  stage_id:
                    type: integer
                  status:
                    description: "Descriptions:\r\n- `open`: An active, sales qualified
                      prospect\r\n- `draft`: A prospect in the process of being added
                      by a user. You should generally\nignore these prospects.\n\r\n-
                      `closed`: A closed/lost prospect\r\n- `moved_in`: A prospect
                      that has moved in at some point. Note this Prospect could\nrepresent
                      a former resident.\n\r\n- `marketing_qualified`: A marketing
                      qualified prospect. These prospects are not visible to users.\n"
                    enum:
                    - open
                    - draft
                    - closed
                    - moved_in
                    - marketing_qualified
                    type: string
                  status_changed_at:
                    type: string
                    format: date-time
                  trait_ids:
                    type: array
                  updated_at:
                    type: string
                    format: date-time
                  residents_attributes:
                    type: array
                    items:
                      type: object
                      properties:
                        id:
                          type: integer
                        person_attributes:
                          type: object
                          properties:
                            id:
                              type: integer
                            first_name:
                              type: string
                              nullable: true
                            middle_name:
                              type: string
                              nullable: true
                            last_name:
                              type: string
                              nullable: true
                            cell_phone:
                              type: string
                              nullable: true
                            home_phone:
                              type: string
                              nullable: true
                            work_phone:
                              type: string
                              nullable: true
                            email:
                              type: string
                              nullable: true
                            fax_number:
                              type: string
                              nullable: true
                            do_not_call:
                              type: boolean
                              default: false
                            do_not_email:
                              type: boolean
                              default: false
                            do_not_mail:
                              type: boolean
                              default: false
                            do_not_text:
                              type: boolean
                              default: false
                            birthdate:
                              type: string
                              nullable: true
                            provided_age:
                              type: integer
                              nullable: true
                            gender:
                              type: string
                              enum:
                              - male
                              - female
                              nullable: true
                            address_attributes:
                              type: object
                              properties:
                                line1:
                                  type: string
                                  nullable: true
                                line2:
                                  type: string
                                  nullable: true
                                city:
                                  type: string
                                  nullable: true
                                state:
                                  type: string
                                  nullable: true
                                zip:
                                  type: string
                                  nullable: true
                        care_type_id:
                          type: integer
                          nullable: true
                        marital_status:
                          type: string
                          nullable: true
                          enum:
                          - single
                          - married
                          - partnered
                          - widowed
                          - divorced
[...]
